package ISDVMIEncode;
# %Z%%M%------- %I%- %W% %G% %U% 
# Licensed Materials - Property of IBM
#
# (C) Copyright IBM Corp. 2009, 2013 All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplicate or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp.

use strict;
use warnings;
require Exporter;

our @ISA=qw(Exporter);
our @EXPORT=qw(decode encode crypt_passwd);
our @VERSION=1.0;

# XOR a string with 0x5f
sub ibmxor
{
    my ($string) = @_;
    my @chars;

    @chars = unpack('C*', $string);
    for my $cnt (0 .. $#chars) { $chars[$cnt] ^= 0x5f; };

    return pack('C*', @chars);
};
sub decode
{
   my ($encrypted) = @_;
    my @cmd = ("/opt/ibm/director/vmi/bin/execWithPrivilege",  "aestool",  "-d", " $encrypted");
return `@cmd`;

};

sub encode
{
  my $plaintext = $_[0]; 
   my @cmd = ("/opt/ibm/director/vmi/bin/execWithPrivilege", "aestool",  "-e", " $plaintext");

return `@cmd`;

}

# crypt the password, just like what Linux do in /etc/shadow
sub crypt_passwd
{
    my $passwd = $_[0];
    my @chars=('0'..'9', 'a'..'z', 'A'..'Z', "./");
    my $salt ='$6$';
    foreach (0 .. 15){
        $salt .= $chars [rand (@chars)];
    }
    $salt .='$';
    my $encrypted_passwd=crypt ($passwd, $salt);
    return $encrypted_passwd;
}

