#!/usr/bin/perl -w
#
# Licensed Materials - Property of IBM
#
# (C) Copyright IBM Corp. 2009, 2013 All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplicate or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp.
#

use warnings;
use strict;
use Getopt::Long;


my %options = ();
my $MARKFILE = "/opt/ibm/director/vmi/data/keycfgcheck";
my $COMMAND = "/opt/ibm/director/vmi/scripts/execWithPrivilege/cfgkbd";
my $keyboardtype="us";

if (! (GetOptions (\%options, 'keyboardtype=s'))) {
    print "no option input.\n"; 
    exit (1); 
}
print "keyboardtype is $keyboardtype \n";

if ( defined $options{'keyboardtype'} && ! $options{'keyboardtype'} eq ""){
    $keyboardtype=$options{'keyboardtype'};
}

# Config keyboard with option
unless (-e $MARKFILE){
    if (system "$COMMAND $keyboardtype"){
        print "Keyboard configuration failed!\n";
	exit(1);
    }
}

