<?xml version="1.0" encoding="UTF-8"?>
<!-- %Z%%M%____ %I%- %W% %G% %U% -->
<virtual-image name="vmibase">
    <software-resource name="vmibase">
        <!-- the license should be accept first -->
        <configuration name="license">
            <script file="AS/license.pl" />
            <service name="activation.license">
                <runlevel value="B" />
                <dependency service="boot.localnet boot.install" />
            </service>
        </configuration>
	<configuration name="cfgdatetime">
            <script file="AS/cfgdatetime.pl" />
            <service name="activation.cfgdatetime">
                <runlevel value="B" />
                <dependency service="activation.license" />
            </service>
        </configuration>
        <configuration name="ConfigureNetwork">
            <script file="AS/cfgnetwork.pl" />
            <service name="activation.cfgnetwork">
                <runlevel value="B" />
                <dependency service="activation.license" />
            </service>
        </configuration>
        <configuration name="cfgeth0">
            <script file="AS/cfgeth.pl" />
            <service name="activation.cfgeth0">
                <runlevel value="B" />
                <dependency service="activation.cfgnetwork" />
            </service>
        </configuration>
        <configuration name="cfgeth1">
            <script file="AS/cfgeth.pl" />
            <service name="activation.cfgeth1">
                <runlevel value="B" />
                <dependency service="activation.cfgnetwork" />
            </service>
        </configuration>
        <configuration name="cfgeth2">
            <script file="AS/cfgeth.pl" />
            <service name="activation.cfgeth2">
                <runlevel value="B" />
                <dependency service="activation.cfgnetwork" />
            </service>
        </configuration>
        <configuration name="cfgeth3">
            <script file="AS/cfgeth.pl" />
            <service name="activation.cfgeth3">
                <runlevel value="B" />
                <dependency service="activation.cfgnetwork" />
            </service>
        </configuration>

	<configuration name="cfghostgateway">
            <script file="AS/cfghostgateway.pl" />
            <service name="activation.cfghostgateway">
                <runlevel value="B" />
                <dependency service="activation.cfgeth0 activation.cfgeth1 activation.cfgeth2 activation.cfgeth3 activation.cfgnetwork" />
            </service>
        </configuration>

        <configuration name="cfgdns">
            <script file="AS/cfgdns.pl" />
            <service name="activation.cfgdns">
                <runlevel value="B" />
                <dependency service="activation.cfgeth0 activation.cfgeth1 activation.cfgeth2 activation.cfgeth3 activation.cfgnetwork" />
            </service>
        </configuration>

        <configuration name="agentmgr">
            <script file="AS/agentmgr.pl" />
            <service name="activation.agentmgr">
                <runlevel value="B" />
                <dependency service="activation.cfgdns" />
            </service>
        </configuration>
        <configuration name="sysadmin">
            <script file="AS/chpasswd.pl" />
            <service name="activation.sysadmin">
                <runlevel value="B" />
                <dependency service="activation.cfgdns" />
            </service>
        </configuration>
        <configuration name="root">
            <script file="AS/chpasswd.pl" />
            <service name="activation.root">
                <runlevel value="B" />
                <dependency service="activation.cfgdns" />
            </service>
        </configuration>
        <configuration name="pe">
            <script file="AS/chpasswd.pl" />
            <service name="activation.pe">
                <runlevel value="B" />
                <dependency service="activation.cfgdns" />
            </service>
        </configuration>
        <configuration name="newusers">
            <script file="AS/newusers.pl" />
            <!-- the service name cannot in this patterm *.new*, so rename it to activation.createusers -->
            <service name="activation.createusers">
                <runlevel value="B" />
                <dependency service="activation.cfgdns" />
            </service>
        </configuration>
        <configuration name="firewall0">
            <script file="AS/firewall.pl" />
            <service name="activation.firewall0">
                <runlevel value="B" />
                <dependency service="activation.cfgdns" />
            </service>
        </configuration>
        <configuration name="firewall1">
            <script file="AS/firewall.pl" />
            <service name="activation.firewall1">
                <runlevel value="B" />
                <dependency service="activation.cfgdns" />
            </service>
        </configuration>
        <configuration name="firewall2">
            <script file="AS/firewall.pl" />
            <service name="activation.firewall2">
                <runlevel value="B" />
                <dependency service="activation.cfgdns" />
            </service>
        </configuration>
        <configuration name="firewall3">
            <script file="AS/firewall.pl" />
            <service name="activation.firewall3">
                <runlevel value="B" />
                <dependency service="activation.cfgdns" />
            </service>
        </configuration>
        <configuration name="locale">
            <script file="AS/locale.pl" />
            <service name="activation.locale">
                <runlevel value="B" />
                <dependency service="activation.license" />
            </service>
        </configuration>
        <configuration name="keyboard">
            <script file="AS/keyboard.pl" />
            <service name="activation.keyboard">
                <runlevel value="B" />
                <dependency service="activation.license" />
            </service>
        </configuration>
        <!-- when all configuration done, then disable the setup wizard -->
        <configuration name="nowizard">
            <script file="AS/nowizard.pl" />
            <service name="activation.nowizard">
                <runlevel value="B" />
                <dependency service="activation.agentmgr activation.sysadmin activation.root activation.pe activation.createusers activation.firewall0 activation.firewall1 activation.firewall2 activation.firewall3 activation.locale"/>
            </service>
        </configuration>
    </software-resource>
</virtual-image>

